frontend http-in
    bind *:80
{% if external_url_ssl and external_ssl_source != '' %}
    bind *:443 ssl crt /usr/local/etc/haproxy/{{ external_host }}.pem

    http-request redirect scheme https unless { ssl_fc }
    http-request set-header X-Forwarded-Proto https if { ssl_fc }
    http-request set-header X-Forwarded-Ssl on if { ssl_fc }
{% endif %}

{% if 'monitor' in groups %}
    acl grafana path_beg -i /-/grafana
    use_backend grafana if grafana
{% endif %}

    default_backend gitlab-rails

frontend gitlab-ssh-in
    bind *:2222
    mode tcp
    option tcplog
    option clitcpka

    default_backend gitlab-rails-ssh

{% if 'monitor' in groups %}
frontend prometheus
    bind *:9090

    default_backend prometheus
{% endif %}

{% if 'elastic' in groups %}
frontend kibana
    bind *:5601

    default_backend kibana
{% endif %}

backend gitlab-rails
    option httpchk GET /-/readiness

{% for ip in gitlab_rails_int_ips %}
    server gitlab-rails{{loop.index}} {{ ip }}:80 check inter 3s fall 1
{% endfor %}

backend gitlab-rails-ssh
    mode tcp
    option tcp-check
    option httpchk GET /-/readiness
    option srvtcpka

{% for ip in gitlab_rails_int_ips %}
    server gitlab-rails{{loop.index}} {{ ip }}:22 track gitlab-rails/gitlab-rails{{loop.index}}
{% endfor %}

{% if 'monitor' in groups %}
backend grafana
    option httpchk GET /-/grafana/api/health

    server grafana {{ monitor_int_ip }}:80 check

backend prometheus
    option httpchk GET /-/healthy

    server prometheus {{ monitor_int_ip }}:9090 check
{% endif %}

{% if 'elastic' in groups %}
backend kibana
    option httpchk GET /api/status

    server kibana {{ elastic_primary_int_ip }}:5601 check inter 10s fall 1
{% endif %}
